unit modulelist;

interface
uses classes,windows,addon;

type

TModuleList=class
private
 flist:TInterfaceList;
 floadedlibs:TList;
public
 property List:TInterfaceList read flist write flist;
 procedure Clear;
 procedure LoadModule(const libname:string);
 constructor create;
 destructor destroy;override;
end;

implementation

procedure TModuleList.Clear;
var
 i:integer;
begin
 List.Clear;
for i:=0 to floadedlibs.Count-1 do
 FreeLibrary(Cardinal(floadedlibs));

end;

procedure TModuleList.LoadModule(const libname:string);
var
 lib:Cardinal;
 i:integer;
 GetModuleCount:function:integer;
 CreateModule:function(index:integer):IBenchmarkModule;
begin
lib:=LoadLibrary(pchar(libname));
GetModuleCount:=GetProcAddress(lib,'GetModuleCount');
if @GetModuleCount=nil then
begin
 FreeLibrary(lib);
 exit;
end;
CreateModule:=GetProcAddress(lib,'CreateModule');
if @CreateModule=nil then
begin
 FreeLibrary(lib);
 exit;
end;
floadedlibs.Add(pointer(lib));
for i:=0 to GetModuleCount-1 do
 flist.Add(CreateModule(i));
end;

constructor TModuleList.create;
begin
inherited;
flist:=TInterfaceList.Create;
floadedlibs:=TList.Create;
end;

destructor TModuleList.destroy;
begin
Clear;
flist.Free;
floadedlibs.Free;
inherited;
end;


end.
